/*
		Master Chess v 1.0 - String Generator Interface for Arduino

		Copyright (C) 2012 Ponto Crítico Engineering - pontocriticoengieering.wordpress.com
		Gabriel Herman Bernardim Andrade, Gustavo Ribeiro Siqueira, Luís Felipe Nogoseke

		email:	ponto.critico@live.com
		
		This programm is free software; you can redistribute it and/or
		modify it under the terms of the GNU General Public License as
		published by the Free Software Foundation; either version 2 of
		the License, or (at your option) any later version.
		
		This program is distributed in the hope that it will be useful,
		but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
		General Public License for more details.
		
		You should have received a copy of the GNU General Public License
		along with this program; if not, write to the Free Software
		Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


*/

package masterchess;

public class StringGenerator {

	 public static int j = 0;
	 public static String JogadaHumana = new String();
	 public static String JogadaMáquina = new String();
	 public static String Arduino = new String();
	 
	 public static Integer Vinit;
	 public static Integer Hinit;
	 public static Integer Vend;
	 public static Integer Hend;
	 public static String Coordenadas = new String();
	 
	
	public static void StringArduino(int start, int end, int boardstart, int boardend, String Fim){
			
		if (j == 0){ //Jogada humana
			j++;

			//Parte para o display - vai direto para a string do arduino
			Arduino = StringDisplay(start);
			Arduino = Arduino.concat(StringDisplay(end));
			Arduino = Arduino.concat(",");
			
			//Processamento da jogada
			CalculaCoordenadas(start, end);
			JogadaHumana = TipoMovimento(start, end, boardstart);
			JogadaHumana = JogadaHumana.concat(Coordenadas);
			JogadaHumana = JogadaHumana.concat(MatouPeça(boardend));
	
			}
		
		else{ //Jogada da máquina
			j--;
					
//			String JogadaMáquina = new String();
			
			//Parte para o display
			Arduino = Arduino.concat(StringDisplay(start));
			Arduino = Arduino.concat(StringDisplay(end));
			Arduino = Arduino.concat(";");
			
			//Processamento da jogada
			CalculaCoordenadas(start, end);
			JogadaMáquina = TipoMovimento(start, end, boardstart);
			JogadaMáquina = JogadaMáquina.concat(Coordenadas);
			JogadaMáquina = JogadaMáquina.concat(MatouPeça(boardend));
			
			//Checa fim de jogo
						
			
			//Junta a string da jogada humana + jogada da máquina
			Arduino = Arduino.concat(JogadaHumana);
			Arduino = Arduino.concat(JogadaMáquina);
			Arduino = Arduino.concat(Fim);
		
		}
	}
	
	
	//Gera as coordenadas do tabuleiro físico
	public static void CalculaCoordenadas(int start, int end){
		//Posição inicial
		//Movimentação vertical
		Vinit = 10 - (start / 10); 
		//Movimentação horizontal
		Hinit = (start % 10) - 1;
		
		//Posição final
		//Movimentação vertical
		Vend = 10 - (end / 10); 
		//Movimentação horizontal
		Hend = (end % 10) - 1;
		
		//Converte para String
		Coordenadas = (Integer.toString(Vinit));
		Coordenadas = Coordenadas.concat(";");
		Coordenadas = Coordenadas.concat(Integer.toString(Hinit));
		Coordenadas = Coordenadas.concat(";");
		Coordenadas = Coordenadas.concat(Integer.toString(Vend));
		Coordenadas = Coordenadas.concat(";");
		Coordenadas = Coordenadas.concat(Integer.toString(Hend));
		Coordenadas = Coordenadas.concat(";");
	}
	
	//Gera o char do Tipo de Movimentação
	public static String TipoMovimento(int start, int end, int boardstart){
								
		if(boardstart == 116 || boardstart == 126){ 
			if((start == 95 && end == 97) || (start == 25 && end == 27))
				return("r");
			if((start == 95 && end == 93) || (start == 25 && end == 23))
				return("R"); 
		}
		if(boardstart == 12 || boardstart == 22) // Testa movimento do cavalo
			return("c");
		if((Math.abs(Vend - Vinit)) == (Math.abs(Hend - Hinit))) //Testa movimento na diagonal
			return("d");
		if ((Vend - Vinit) == 0 || (Hend - Hinit) == 0) //Movimento retilíneo
			return("v");
		else
		return ("a");
	}
	
	//Checa se uma peça foi capturada nessa jogada
	public static String MatouPeça(int boardend){
		
		if(boardend != 00)
			return("m;");
		else
			return("n;");
		}
		
	
	//Converte para string do display
	public static String StringDisplay(int posição){
		String Display = new String();
		
		switch (posição){
		
		case 21: Display ="a8"; break;
		case 22: Display ="b8"; break;
		case 23: Display ="c8"; break;
		case 24: Display ="d8"; break;
		case 25: Display ="e8"; break;
		case 26: Display ="f8"; break;
		case 27: Display ="g8"; break;
		case 28: Display ="h8"; break;
		
		case 31: Display ="a7"; break;
		case 32: Display ="b7"; break;
		case 33: Display ="c7"; break;
		case 34: Display ="d7"; break;
		case 35: Display ="e7"; break;
		case 36: Display ="f7"; break;
		case 37: Display ="g7"; break;
		case 38: Display ="h7"; break;
		
		case 41: Display ="a6"; break;
		case 42: Display ="b6"; break;
		case 43: Display ="c6"; break;
		case 44: Display ="d6"; break;
		case 45: Display ="e6"; break;
		case 46: Display ="f6"; break;
		case 47: Display ="g6"; break;
		case 48: Display ="h6"; break;
		
		case 51: Display ="a5"; break;
		case 52: Display ="b5"; break;
		case 53: Display ="c5"; break;
		case 54: Display ="d5"; break;
		case 55: Display ="e5"; break;
		case 56: Display ="f5"; break;
		case 57: Display ="g5"; break;
		case 58: Display ="h5"; break;		
		
		case 61: Display ="a4"; break;
		case 62: Display ="b4"; break;
		case 63: Display ="c4"; break;
		case 64: Display ="d4"; break;
		case 65: Display ="e4"; break;
		case 66: Display ="f4"; break;
		case 67: Display ="g4"; break;
		case 68: Display ="h4"; break;
		
		case 71: Display ="a3"; break;
		case 72: Display ="b3"; break;
		case 73: Display ="c3"; break;
		case 74: Display ="d3"; break;
		case 75: Display ="e3"; break;
		case 76: Display ="f3"; break;
		case 77: Display ="g3"; break;
		case 78: Display ="h3"; break;
		
		case 81: Display ="a2"; break;
		case 82: Display ="b2"; break;
		case 83: Display ="c2"; break;
		case 84: Display ="d2"; break;
		case 85: Display ="e2"; break;
		case 86: Display ="f2"; break;
		case 87: Display ="g2"; break;
		case 88: Display ="h2"; break;
		
		case 91: Display ="a1"; break;
		case 92: Display ="b1"; break;
		case 93: Display ="c1"; break;
		case 94: Display ="d1"; break;
		case 95: Display ="e1"; break;
		case 96: Display ="f1"; break;
		case 97: Display ="g1"; break;
		case 98: Display ="h1"; break;
		}
			
		return Display;
		}
	
}
